<?php
namespace Service;

use \Doctrine\ORM\EntityManager;
use Util\Utilities;
use Util\Instance\GeneralProvider;
use Util\Messages;
use Util\Instance\RepositoryInstance;
use Util\Instance\FactoryInstance;
use Teknisa\Libs\Util\Environment as TeknisaEnvironment;


class Objects {

    public function __construct(
        TeknisaEnvironment $environment
    ){
        $this->environment = $environment;
    }

    public function findObjectsBody($objectName, $objectType, $typeAbbreviation)
    {
        $return = array();
        if($objectType){
            $body = RepositoryInstance::getObjects()->getObjectsBody($objectName, $objectType);
            $return["BODY"] = $body[0]["SQL"];
        }
        $observation = RepositoryInstance::getObjects()->findObjectsObservation($objectName, $typeAbbreviation);
        if($observation){
            $return["OBSERVATION"] = $observation[0]["DSOBJETO"];
        }
        return $return;
    }

    public function saveObjectObservation($object, $type, $observation)
    {
        $repository    = RepositoryInstance::getObjeto();
        $entityManager = GeneralProvider::getEntityManager();
        $connection    = $entityManager->getConnection();
        try {
            $connection->beginTransaction();
            $objectEntity = $repository->findOneBy(array('nmobjeto' => $object, 'idtpobjeto' => $type));
            $currentUser = $this->environment->getCurrentUserId();
            $nrorg = $this->environment->getCurrentOrganizationId();
            if($observation) {
                $tableFactory = FactoryInstance::getObjects()->saveObservation($objectEntity, $observation, $object, $type, $currentUser, $nrorg);
                $entityManager->persist($tableFactory);
                $entityManager->flush();
            } else {
                $entityManager->remove($objectEntity);
                $entityManager->flush();
            }
            $connection->commit();
            return true;
        } catch (\Exception $ex) {
            $connection->rollback();
            throw $ex;
        }
    }
}