CREATE OR REPLACE PROCEDURE ETL_RAST_PRODUTO_PLANEJADO (P_DTINI IN DATE,
                                                          P_DTFINA IN DATE)

IS
   V_DTFIM                      DATE;
   V_DTINI                      DATE;
   V_DATAFINAL                  DATE;
   V_DTULTCOMEFE                DATE;
   V_FIM                        DATE;
   V_DTPOSESTCON                DATE;
   V_NMTIPOCUSTO1               TIPOCUSTO.NMTIPOCUSTO%TYPE;
   V_NMTIPOCUSTO2               TIPOCUSTO.NMTIPOCUSTO%TYPE;
   V_NMTIPOCUSTO3               TIPOCUSTO.NMTIPOCUSTO%TYPE;
   V_NRTIPOCUSTO1               NUMBER;
   V_NRTIPOCUSTO2               NUMBER;
   V_NRTIPOCUSTO3               NUMBER;
   V_CDTPOCUSTO_PADRAO          NUMBER;
   V_TIPO_LANC                  NUMBER;
   V_COUNTER                    NUMBER NOT NULL := 0;
   V_CDSEQUENCIAL               VARCHAR2(20);
   V_MES                        VARCHAR2(10);
   V_ANO                        VARCHAR2(10);
   V_BIM                        VARCHAR2(10);
   V_TRI                        VARCHAR2(10);
   V_SEM                        VARCHAR2(10);
   V_DATACUSTOBI                VARCHAR2(01)   := 1;
   V_CDCLIENTE                  VARCHAR2(21)   := NULL;
   V_VRCUSTPADR                 FLOAT NOT NULL := 0;
   V_VRPRECVENDA                FLOAT NOT NULL := 0;
   V_ZERO                       FLOAT := 0;
   V_VR_ENTRADAS_NF             FLOAT := 0; 
   V_QT_ENTRADAS_NF             FLOAT := 0;
   V_VR_ENTRADAS_NF_NAO_OK      FLOAT := 0;
   V_QT_ENTRADAS_NF_NAO_OK      FLOAT := 0;
   V_VR_SAIDAS_NF               FLOAT := 0; 
   V_QT_SAIDAS_NF               FLOAT := 0;
   V_VR_SAIDAS_NF_NAO_OK        FLOAT := 0;
   V_QT_SAIDAS_NF_NAO_OK        FLOAT := 0;
   V_VR_DEVOLUCOES_NF           FLOAT := 0;
   V_QT_DEVOLUCOES_NF           FLOAT := 0;
   V_VR_RETIRADAS_TOTAL         FLOAT := 0; 
   V_QT_RETIRADAS_TOTAL         FLOAT := 0;
   V_VR_RETIRADAS_TOTAL_NAO_OK  FLOAT := 0; 
   V_QT_RETIRADAS_TOTAL_NAO_OK  FLOAT := 0;
   V_QT_ESTOQUE_INICIAL         FLOAT := 0;
   V_VR_ESTOQUE_INICIAL         FLOAT := 0;
   V_CUSTO_UNIT_ESTOQUE         FLOAT := 0;
   V_QT_ESTOQUE_FINAL           FLOAT := 0;
   V_VR_ESTOQUE_FINAL           FLOAT := 0;
   V_QT_EFETIVAMENTE_SOLICITADA FLOAT := 0;
   V_QT_ORIGINAL_SOLICITADA     FLOAT := 0;
   V_QT_PLANEJADA               FLOAT := 0;




FUNCTION RETORNA_DTPOSESTCON(P_PERIODO IN VARCHAR, P_CDFILIAL IN VARCHAR, P_CDPRODESTO IN VARCHAR) RETURN DATE
IS    

BEGIN
  SELECT MAX(POSESTCONS.DTPOSESTCON)
  INTO V_DTPOSESTCON
   FROM POSESTCONS
   WHERE (POSESTCONS.DTPOSESTCON <= P_PERIODO)
     AND POSESTCONS.CDFILIAL =P_CDFILIAL
     AND POSESTCONS.CDPRODUTO =P_CDPRODESTO;
                             
RETURN V_DTPOSESTCON; 

END;

BEGIN

   V_MES  :=  TO_CHAR(P_DTINI,'MM');
   V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');
   V_NMTIPOCUSTO1 := ' ';
   V_NMTIPOCUSTO2 := ' ';
   V_NMTIPOCUSTO3 := ' ';
   V_DTINI := ADD_MONTHS(LAST_DAY(P_DTINI) + 1, -1);
   V_FIM := LAST_DAY(P_DTFINA);
 

-----------------------------INICIO DA ROTINA DE DELEO DE DADOS------------------------------------

   FOR C_DEL_SRV IN (SELECT ROWID REG_DEL
                     FROM DM_RAST_PRODUTO_PLANEJADO
                     WHERE TO_DATE('01'||CDMESBI||CDANOBI, 'DD/MM/YYYY') >= V_DTINI)

   LOOP
      V_COUNTER := V_COUNTER +1;
      DELETE
      FROM DM_RAST_PRODUTO_PLANEJADO
      WHERE C_DEL_SRV.REG_DEL = ROWID;

      IF V_COUNTER >= 2000 THEN
         COMMIT;
         V_COUNTER := 0;
      END IF;
   END LOOP;
   COMMIT;
   V_COUNTER := 0;
  ----------------------------------------FIM DA DELEO DOS DADOS--------------------------------------

   SELECT IDDATACUSTOBI INTO V_DATACUSTOBI FROM PARAMGERAL;

    FOR C_NRTPCUS IN(SELECT ROWNUM AS LINHA, NRTIPOCUSTO, NMTIPOCUSTO 
                    FROM(SELECT TO_NUMBER(CDTIPOCUSTO) NRTIPOCUSTO, NMTIPOCUSTO 
                           FROM TIPOCUSTO 
                          WHERE IDTPCUSTOGSC = 'S' 
                          ORDER BY NRTIPOCUSTO))LOOP 
   
      CASE C_NRTPCUS.LINHA
        WHEN 1 THEN V_NRTIPOCUSTO1 := C_NRTPCUS.NRTIPOCUSTO; 
                    V_NMTIPOCUSTO1 := C_NRTPCUS.NMTIPOCUSTO;
        
        WHEN 2 THEN V_NRTIPOCUSTO2 := C_NRTPCUS.NRTIPOCUSTO; 
                    V_NMTIPOCUSTO2 := C_NRTPCUS.NMTIPOCUSTO;
        
        ELSE  V_NRTIPOCUSTO3 := C_NRTPCUS.NRTIPOCUSTO; 
              V_NMTIPOCUSTO3 := C_NRTPCUS.NMTIPOCUSTO; 
      END CASE;
      
   END LOOP;

   WHILE (V_DTINI  <=  V_FIM)
   LOOP
   BEGIN
      V_DTFIM     := LAST_DAY( V_DTINI);
      V_DATAFINAL := TRUNC(V_DTFIM); 
      V_MES       := TO_CHAR(V_DTFIM,'MM');
      V_ANO       := TO_CHAR(V_DTFIM,'YYYY');
      V_BIM       := TO_CHAR(TRUNC((V_MES - 1) / 2) + 1);
      V_TRI       := TO_CHAR(TRUNC((V_MES - 1) / 3) + 1);
      V_SEM       := TO_CHAR(TRUNC((V_MES - 1) / 6) + 1);
      
     FOR C_CENTRAL_MERENDA IN(SELECT CENTRAL.CDCENTRAL, CENTRAL.NMCENTRAL, P.IDCOMCUSPERC, FL.CDFILIAL CDMERENDA, FL.NMFILIAL NMMERENDA, FL.CDEMPRESA, EMP.NMEMPRESA,
     FL.CDAREAGERE, NVL(AREAGERE.NMAREAGERE,'SEM CADASTRO') NMAREAGERE,
                                     FL.CDSUPERVISOR, NVL(SUPERVISOR.NMOPERADOR,'SEM CADASTRO') NMSUPERVISOR, FL.CDGOPERAC, NVL(GERENTE_OPERACIONAL.NMOPERADOR,'SEM CADASTRO') NMGERENTE_OPERACIONAL, 
                                     FL.CDSEGMER, NVL(SEGMERCADO.DSSEGMER,'SEM CADASTRO') NMSEGMERCADO, CDPLANEJADORA, NVL(PLANEJADORA.NMOPERADOR,'SEM CADASTRO') NMPLANEJADORA, CDGUNIDADE, NVL(GERENTE_UNIDADE.NMOPERADOR,'SEM CADASTRO') NMGUNIDADE
                                 FROM FILIAL FL
                                INNER JOIN (SELECT CDFILIAL CDCENTRAL, NMFILIAL NMCENTRAL FROM FILIAL WHERE IDFILCENTPME = 'S' AND IDTPFILIALCENT = 'M') CENTRAL
                                   ON FL.CDFILCENTPME = CENTRAL.CDCENTRAL
                                INNER JOIN PARAMFILIAL P
                                   ON P.CDFILIAL = CENTRAL.CDCENTRAL
                                INNER JOIN EMPRESA EMP
                                   ON EMP.CDEMPRESA = FL.CDEMPRESA
                                 LEFT JOIN OPERADOR SUPERVISOR
                                   ON FL.CDSUPERVISOR = SUPERVISOR.CDOPERADOR
                                 LEFT JOIN SEGMERCADO
                                   ON FL.CDSEGMER = SEGMERCADO.CDSEGMER
                                 LEFT JOIN OPERADOR GERENTE_OPERACIONAL
                                   ON FL.CDGOPERAC = GERENTE_OPERACIONAL.CDOPERADOR
                                 LEFT JOIN AREAGERE
                                   ON FL.CDAREAGERE = AREAGERE.CDAREAGERE
                                 LEFT JOIN OPERADOR PLANEJADORA
                                   ON FL.CDPLANEJADORA = PLANEJADORA.CDOPERADOR
                                 LEFT JOIN OPERADOR GERENTE_UNIDADE
                                   ON FL.CDGUNIDADE = GERENTE_UNIDADE.CDOPERADOR)LOOP-- WHERE FL.CDFILIAL IN ('2040','2011','2357')
     
         NOVO_CODIGO('CONSPLAN'||C_CENTRAL_MERENDA.CDMERENDA, V_CDSEQUENCIAL,1); 
         V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10); 
         
         /*CONSUMO_PLANEJADO_PME(CENTRAL DE MERENDA, TIPO DE CARDAPIO, FILIAL MERENDA, SERVICO, PERIODO INICIAL, PERIODO FINAL, ?, CALCULO(C-CARDAPIO/F-CONSUMO FIXO/P-CONSUMO PERCAPITA), ?, ACRESCIMO, ARREDONDAMENTO, SEQUENCIAL, PRODUTO INICIAL, PRODUTO FINAL, OPERADOR)
                                    */
         CONSUMO_PLANEJADO_PME( C_CENTRAL_MERENDA.CDCENTRAL, NULL, C_CENTRAL_MERENDA.CDMERENDA, NULL, V_DTINI, V_DATAFINAL, 'T', 'CFP', 'N', 0, 'N', V_CDSEQUENCIAL, '0', 'zzzzzzzzzz', ''); 
                                         
                      FOR C_PRODUTO IN(SELECT P.CDPRODUTO, P.NMPRODUTO, VRARREDCMP, VRFATOCONV, DTMESCARD
                                         FROM(SELECT CDPRODCPLA CDPRODUTO,  TRUNC(MIN(DTCONSPLAN),'MM') DTMESCARD
                                                FROM CONSPLAN CP
                                               WHERE TO_CHAR(DTCONSPLAN, 'YYYYMM') = TO_CHAR(TO_DATE(V_DATAFINAL),'YYYYMM')
                                                 AND CDFILCENTPME = C_CENTRAL_MERENDA.CDCENTRAL     
                                                 AND CDFILICPLA = C_CENTRAL_MERENDA.CDMERENDA
                                                 AND NRCONSPLAN = V_CDSEQUENCIAL
                                               GROUP BY CDPRODCPLA
                                               UNION
                                              SELECT CDPRODUTO, TRUNC(MIN(IT.DTLANCMOVI),'MM') DTMESCARD
                                                FROM ITLANCTOEST IT
                                               WHERE TO_CHAR(IT.DTLANCMOVI, 'YYYYMM') = TO_CHAR(TO_DATE(V_DATAFINAL),'YYYYMM')
                                                 AND IT.CDFILIMOVI = C_CENTRAL_MERENDA.CDMERENDA
                                                 AND IT.IDTIPOMOVI IN (2, 3, 4)
                                               GROUP BY CDPRODUTO) PROD_PLAN, PRODUTO P
                                        WHERE PROD_PLAN.CDPRODUTO = P.CDPRODUTO
                                        GROUP BY P.CDPRODUTO, P.NMPRODUTO, VRARREDCMP, VRFATOCONV, DTMESCARD
                                        ORDER BY P.CDPRODUTO)LOOP
                      BEGIN
                       SELECT DECODE(CDTIPCUSTEST,NULL,'03',CDTIPCUSTEST)
                         INTO V_CDTPOCUSTO_PADRAO
                         FROM PARAMFILIAL
                        WHERE CDFILIAL = C_CENTRAL_MERENDA.CDMERENDA;
                      EXCEPTION 
                        WHEN OTHERS THEN
                        V_CDTPOCUSTO_PADRAO := '03';
                      END;
                      ------------------------------------------------------------------------------
                      --------------------------- CONSULTA CONSUMO PLANEJADO------------------------
                      BEGIN 
                         SELECT SUM(QTCONSPLAN) 
                           INTO V_QT_PLANEJADA
                           FROM CONSPLAN 
                          WHERE CDFILICPLA   = C_CENTRAL_MERENDA.CDMERENDA
                            AND CDPRODCPLA   = C_PRODUTO.CDPRODUTO
                            AND NRCONSPLAN   = V_CDSEQUENCIAL
                            AND CDFILCENTPME = C_CENTRAL_MERENDA.CDCENTRAL
                          ORDER BY DTCONSPLAN;
                      EXCEPTION 
                            WHEN OTHERS THEN 
                            V_QT_PLANEJADA := 0; 
                      END;
                      
                      ------------------------------------------------------------------------------
                      -------------------------------CONSULTA ENTRADAS_NF---------------------------
                        V_TIPO_LANC := 2;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(VRLANCTOEST * QTLANCTOEST),0)), --ITLANCTOEST.IDEVOLESTOQ = 'S' /*SOMENTE O LANCAMENTOS QUE EVOLUI ESTOQUE*/
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(VRLANCTOEST * QTLANCTOEST),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST),0))
                             INTO V_VR_ENTRADAS_NF, V_QT_ENTRADAS_NF, V_VR_ENTRADAS_NF_NAO_OK, V_QT_ENTRADAS_NF_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_CENTRAL_MERENDA.CDMERENDA
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_ENTRADAS_NF := 0; 
                             V_QT_ENTRADAS_NF := 0;
                             V_VR_ENTRADAS_NF_NAO_OK := 0;
                             V_QT_ENTRADAS_NF_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTAS SAIDAS NF-------------------------------
                      V_TIPO_LANC := 4;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',QTLANCTOEST,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',QTLANCTOEST,0))
                             INTO V_VR_SAIDAS_NF, V_QT_SAIDAS_NF, V_VR_SAIDAS_NF_NAO_OK, V_QT_SAIDAS_NF_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_CENTRAL_MERENDA.CDMERENDA
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_SAIDAS_NF        := 0; 
                             V_QT_SAIDAS_NF        := 0;
                             V_VR_SAIDAS_NF_NAO_OK := 0;
                             V_QT_SAIDAS_NF_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTAS DEVOLUCOES------------------------------
                      V_TIPO_LANC := 5;
                        
                        BEGIN
                           SELECT SUM((QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE)))), 
                                  SUM(QTLANCTOEST)
                             INTO V_VR_DEVOLUCOES_NF, V_QT_DEVOLUCOES_NF
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_CENTRAL_MERENDA.CDMERENDA
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_DEVOLUCOES_NF := 0; 
                             V_QT_DEVOLUCOES_NF := 0;
                        END;
                      -----------------------------------------------------------------------------
                      ----------------------------CONSULTA RETIRADAS-------------------------------
                      V_TIPO_LANC := 3;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))) ,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',QTLANCTOEST,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))) ,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',QTLANCTOEST,0))
                             INTO V_VR_RETIRADAS_TOTAL, V_QT_RETIRADAS_TOTAL, V_VR_RETIRADAS_TOTAL_NAO_OK, V_QT_RETIRADAS_TOTAL_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_CENTRAL_MERENDA.CDMERENDA
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_RETIRADAS_TOTAL        := 0; 
                             V_QT_RETIRADAS_TOTAL        := 0;
                             V_VR_RETIRADAS_TOTAL_NAO_OK := 0; 
                             V_QT_RETIRADAS_TOTAL_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTA ESTOQUE INICIAL--------------------------
                                            
                      V_DTPOSESTCON := TO_CHAR(RETORNA_DTPOSESTCON(TO_DATE(V_DTINI), C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO),'DD/MM/YYYY');
                      V_CUSTO_UNIT_ESTOQUE := CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, V_CDTPOCUSTO_PADRAO, V_DTPOSESTCON, TRUNC(SYSDATE)); 
                        
                        BEGIN
                          SELECT SUM(P.QTESTDIACON), SUM(P.QTESTDIACON * V_CUSTO_UNIT_ESTOQUE)
                            INTO V_QT_ESTOQUE_INICIAL, V_VR_ESTOQUE_INICIAL
                            FROM POSESTCONS P
                           WHERE P.CDFILIAL = C_CENTRAL_MERENDA.CDMERENDA
                             AND P.CDPRODUTO       = C_PRODUTO.CDPRODUTO
                             AND P.QTESTDIACON    <> 0
                             AND P.DTPOSESTCON     = V_DTPOSESTCON;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_QT_ESTOQUE_INICIAL := 0; 
                             V_VR_ESTOQUE_INICIAL := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTA ESTOQUE FINAL----------------------------
                      
                      V_DTPOSESTCON := TO_CHAR(RETORNA_DTPOSESTCON((TO_DATE(V_DATAFINAL)+1), C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO),'DD/MM/YYYY');
                      V_CUSTO_UNIT_ESTOQUE := CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, V_CDTPOCUSTO_PADRAO, V_DTPOSESTCON, TRUNC(SYSDATE)); 
                      
                        BEGIN
                          SELECT SUM(P.QTESTDIACON), SUM(P.QTESTDIACON * V_CUSTO_UNIT_ESTOQUE)
                            INTO V_QT_ESTOQUE_FINAL, V_VR_ESTOQUE_FINAL
                            FROM POSESTCONS P
                           WHERE P.CDFILIAL = C_CENTRAL_MERENDA.CDMERENDA
                             AND P.CDPRODUTO       = C_PRODUTO.CDPRODUTO
                             AND P.QTESTDIACON    <> 0
                             AND P.DTPOSESTCON     = V_DTPOSESTCON;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_QT_ESTOQUE_FINAL := 0; 
                             V_VR_ESTOQUE_FINAL := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ------------------------CONSULTA QUANTIDADE SOLICITADA------------------------
                        
                        BEGIN 
                           IF C_PRODUTO.VRARREDCMP > 0 THEN 
                              SELECT CEIL((SUM(ITS.QTSOLIPROD)/C_PRODUTO.VRFATOCONV)/C_PRODUTO.VRARREDCMP) * C_PRODUTO.VRARREDCMP AS QT_EFETIVAMENTE_SOLICITADA,
                                     CEIL((SUM(CASE WHEN ITS.QTSOLIORIG IS NOT NULL THEN ITS.QTSOLIORIG
                                                    WHEN (SELECT MIN(LOG.DTOPERSOL)
                                                                FROM MOVOPSOL LOG
                                                               WHERE LOG.CDFILSOLMOV = ITS.CDFILSOLI
                                                                 AND LOG.CDFILLANMOV = ITS.CDFILLAN
                                                                 AND LOG.NRSOLIMOV   = ITS.NRSOLICMP
                                                                 AND LOG.CDPRODUTO   = ITS.CDPRODUTO
                                                                 AND ROWNUM = 1
                                                                 AND LOG.DTENTROPER = ITS.DTPROGENTR)IS NOT NULL THEN (SELECT L.QTANTOPER
                                                                                                                      FROM MOVOPSOL L
                                                                                                                     WHERE L.CDFILSOLMOV = ITS.CDFILSOLI
                                                                                                                       AND L.CDFILLANMOV = ITS.CDFILLAN
                                                                                                                       AND L.NRSOLIMOV   = ITS.NRSOLICMP
                                                                                                                       AND L.CDPRODUTO   = ITS.CDPRODUTO
                                                                                                                       AND L.DTENTROPER  = ITS.DTPROGENTR
                                                                                                                       AND ROWNUM=1
                                                                                                                       AND L.DTOPERSOL = (SELECT MIN(LOG.DTOPERSOL)
                                                                                                                                            FROM MOVOPSOL LOG, OPERADOR S
                                                                                                                                           WHERE LOG.CDFILSOLMOV = L.CDFILSOLMOV
                                                                                                                                             AND LOG.CDFILLANMOV = L.CDFILLANMOV
                                                                                                                                             AND LOG.NRSOLIMOV   = L.NRSOLIMOV
                                                                                                                                             AND LOG.CDOPERADOR  = S.CDOPERADOR
                                                                                                                                             AND LOG.CDPRODUTO   = L.CDPRODUTO
                                                                                                                                             AND LOG.DTENTROPER  = L.DTENTROPER))  
                                                    ELSE ITS.QTSOLIPROD END)/C_PRODUTO.VRFATOCONV)/C_PRODUTO.VRARREDCMP) * C_PRODUTO.VRARREDCMP AS QT_ORIGINAL_SOLICITADA
                                INTO V_QT_EFETIVAMENTE_SOLICITADA, V_QT_ORIGINAL_SOLICITADA
                                FROM ITEMSOLI ITS, PRODUTO PS
                               WHERE ITS.CDPRODUTO = PS.CDPRODUTO
                                 AND PS.CDPRODESTO = C_PRODUTO.CDPRODUTO 
                                 AND ITS.CDFILSOLI = C_CENTRAL_MERENDA.CDMERENDA
                                 AND ITS.DTPROGENTR BETWEEN V_DTINI AND V_DATAFINAL;   
                           ELSE 
                              SELECT SUM(ITS.QTSOLIPROD)/C_PRODUTO.VRFATOCONV AS QT_EFETIVAMENTE_SOLICITADA,
                                     SUM(CASE WHEN ITS.QTSOLIORIG IS NOT NULL THEN ITS.QTSOLIORIG
                                              WHEN (SELECT MIN(LOG.DTOPERSOL)
                                                          FROM MOVOPSOL LOG
                                                         WHERE LOG.CDFILSOLMOV = ITS.CDFILSOLI
                                                           AND LOG.CDFILLANMOV = ITS.CDFILLAN
                                                           AND LOG.NRSOLIMOV   = ITS.NRSOLICMP
                                                           AND LOG.CDPRODUTO   = ITS.CDPRODUTO
                                                           AND ROWNUM = 1
                                                           AND LOG.DTENTROPER = ITS.DTPROGENTR)IS NOT NULL THEN (SELECT L.QTANTOPER
                                                                                                                FROM MOVOPSOL L
                                                                                                               WHERE L.CDFILSOLMOV = ITS.CDFILSOLI
                                                                                                                 AND L.CDFILLANMOV = ITS.CDFILLAN
                                                                                                                 AND L.NRSOLIMOV   = ITS.NRSOLICMP
                                                                                                                 AND L.CDPRODUTO   = ITS.CDPRODUTO
                                                                                                                 AND L.DTENTROPER  = ITS.DTPROGENTR
                                                                                                                 AND ROWNUM=1
                                                                                                                 AND L.DTOPERSOL = (SELECT MIN(LOG.DTOPERSOL)
                                                                                                                                      FROM MOVOPSOL LOG, OPERADOR S
                                                                                                                                     WHERE LOG.CDFILSOLMOV = L.CDFILSOLMOV
                                                                                                                                       AND LOG.CDFILLANMOV = L.CDFILLANMOV
                                                                                                                                       AND LOG.NRSOLIMOV   = L.NRSOLIMOV
                                                                                                                                       AND LOG.CDOPERADOR  = S.CDOPERADOR
                                                                                                                                       AND LOG.CDPRODUTO   = L.CDPRODUTO
                                                                                                                                       AND LOG.DTENTROPER  = L.DTENTROPER))  
                                              ELSE ITS.QTSOLIPROD END)/C_PRODUTO.VRFATOCONV AS QT_ORIGINAL_SOLICITADA
                                INTO V_QT_EFETIVAMENTE_SOLICITADA, V_QT_ORIGINAL_SOLICITADA 
                                FROM ITEMSOLI ITS, PRODUTO PS 
                               WHERE ITS.CDPRODUTO = PS.CDPRODUTO
                                 AND PS.CDPRODESTO = C_PRODUTO.CDPRODUTO
                                 AND ITS.CDFILSOLI = C_CENTRAL_MERENDA.CDMERENDA
                                 AND TRUNC(ITS.DTPROGENTR) BETWEEN V_DTINI AND V_DATAFINAL;
                           END IF; 
                        EXCEPTION 
                            WHEN OTHERS THEN 
                            V_QT_EFETIVAMENTE_SOLICITADA := 0; 
                            V_QT_ORIGINAL_SOLICITADA := 0;
                        END; 
                      ------------------------------------------------------------------------------
          
                      INSERT INTO DM_RAST_PRODUTO_PLANEJADO(
                                                   CDFILCENTPME,
                                                   NMFILCENTPME,
                                                   CDFILIAL,
                                                   NMFILIAL,
                                                   CDEMPRESA,
                                                   NMEMPRESA,
                                                   DSMESCARD,
                                                   CDPRODUTO,
                                                   NMPRODUTO,
                                                   CDSEGMERCADO,
                                                   NMSEGMERCADO,
                                                   CDAREAGERE,
                                                   NMAREAGERE,
                                                   CDGOPERAC,
                                                   NMGOPERAC,
                                                   CDSUPERVISOR,
                                                   NMSUPERVISOR,
                                                   CDPLANEJADORA,
                                                   NMPLANEJADORA,
                                                   CDGUNIDADE,
                                                   NMGUNIDADE,
                                                   VRCUST_PLAN1,
                                                   VRCUST_PLAN2,
                                                   VRCUST_PLAN3,
                                                   QTPLANEJADA,
                                                   QT_EFET_SOLICIT,
                                                   QT_ORIG_SOLICIT,
                                                   VRCUST_ULT_COMPRA,
                                                   VRCUST_ESTOQUE,
                                                   VR_ENTRADAS_NF,
                                                   QT_ENTRADAS,
                                                   VR_ENTRADAS_NF_NAO_OK,
                                                   QT_ENTRADAS_NAO_OK,
                                                   VR_SAIDAS,
                                                   QT_SAIDAS,
                                                   VR_SAIDAS_NAO_OK,
                                                   QT_SAIDAS_NAO_OK,
                                                   VR_DEVOLUCOES,
                                                   QT_DEVOLUCOES,
                                                   VR_RETIRADAS,
                                                   QT_RETIRADAS,
                                                   VR_RETIRADAS_NAO_OK,
                                                   QT_RETIRADAS_NAO_OK,
                                                   QT_ESTOQUE_INICIAL,
                                                   VR_ESTOQUE_INICIAL,
                                                   QT_ESTOQUE_FINAL,
                                                   VR_ESTOQUE_FINAL,
                                                   CDANOBI,
                                                   CDMESBI,
                                                   CDMESBI_MMYYYY,
                                                   DSMESBI_MMYYYY,
                                                   DSBIMESTRE,
                                                   DSTRIMESTRE,
                                                   DSQUADIMESTRE,
                                                   DSSEMESTRE)
                                                  
                                            VALUES(
                                                   C_CENTRAL_MERENDA.CDCENTRAL,
                                                   C_CENTRAL_MERENDA.NMCENTRAL,
                                                   C_CENTRAL_MERENDA.CDMERENDA,
                                                   C_CENTRAL_MERENDA.NMMERENDA,
                                                   C_CENTRAL_MERENDA.CDEMPRESA,
                                                   C_CENTRAL_MERENDA.NMEMPRESA,
                                                   C_PRODUTO.DTMESCARD,
                                                   C_PRODUTO.CDPRODUTO,
                                                   C_PRODUTO.NMPRODUTO,
                                                   C_CENTRAL_MERENDA.CDSEGMER,
                                                   C_CENTRAL_MERENDA.NMSEGMERCADO,
                                                   C_CENTRAL_MERENDA.CDAREAGERE,
                                                   C_CENTRAL_MERENDA.NMAREAGERE,
                                                   C_CENTRAL_MERENDA.CDGOPERAC,
                                                   C_CENTRAL_MERENDA.NMGERENTE_OPERACIONAL,
                                                   C_CENTRAL_MERENDA.CDSUPERVISOR,
                                                   C_CENTRAL_MERENDA.NMSUPERVISOR,
                                                   C_CENTRAL_MERENDA.CDPLANEJADORA,
                                                   C_CENTRAL_MERENDA.NMPLANEJADORA,
                                                   C_CENTRAL_MERENDA.CDGUNIDADE,
                                                   C_CENTRAL_MERENDA.NMGUNIDADE,
                                                   NVL(CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO1, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO2, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO3, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(V_QT_PLANEJADA,0),
                                                   NVL(V_QT_EFETIVAMENTE_SOLICITADA,0),
                                                   NVL(V_QT_ORIGINAL_SOLICITADA,0),
                                                   NVL(CUSTO_PRODUTO(C_CENTRAL_MERENDA.CDMERENDA, C_PRODUTO.CDPRODUTO, 8, V_DATAFINAL, TRUNC(SYSDATE)),0),
                                                   NVL(V_CUSTO_UNIT_ESTOQUE,0),
                                                   NVL(V_VR_ENTRADAS_NF,0),
                                                   NVL(V_QT_ENTRADAS_NF,0), 
                                                   NVL(V_VR_ENTRADAS_NF_NAO_OK,0), 
                                                   NVL(V_QT_ENTRADAS_NF_NAO_OK,0),
                                                   NVL(V_VR_SAIDAS_NF,0),
                                                   NVL(V_QT_SAIDAS_NF,0),
                                                   NVL(V_VR_SAIDAS_NF_NAO_OK,0),
                                                   NVL(V_QT_SAIDAS_NF_NAO_OK,0),
                                                   NVL(V_VR_DEVOLUCOES_NF,0),
                                                   NVL(V_QT_DEVOLUCOES_NF,0),
                                                   NVL(V_VR_RETIRADAS_TOTAL,0),
                                                   NVL(V_QT_RETIRADAS_TOTAL,0),
                                                   NVL(V_VR_RETIRADAS_TOTAL_NAO_OK,0),
                                                   NVL(V_QT_RETIRADAS_TOTAL_NAO_OK,0),
                                                   NVL(V_QT_ESTOQUE_INICIAL,0),
                                                   NVL(V_VR_ESTOQUE_INICIAL,0),
                                                   NVL(V_QT_ESTOQUE_FINAL,0),
                                                   NVL(V_VR_ESTOQUE_FINAL,0),
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'YYYY'),--CDANOBI
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MM'),--CDMESBI
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MM/YYYY'),--CDMESBI_MMYYYY
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MON/YYYY'),--DSMESBI_MMYYYY
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 2) + 1)||' Bim',--DSBIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 3) + 1)||' Tri',--DSTRIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 4) + 1)||' Qua',--DSQUADIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 6) + 1)||' Sem'--DSSEMESTRE
                                                   ); 
                                                   COMMIT;
                                                   V_VR_ENTRADAS_NF             := 0; 
                                                   V_QT_ENTRADAS_NF             := 0;
                                                   V_VR_ENTRADAS_NF_NAO_OK      := 0;
                                                   V_QT_ENTRADAS_NF_NAO_OK      := 0;
                                                   V_VR_SAIDAS_NF               := 0; 
                                                   V_QT_SAIDAS_NF               := 0;
                                                   V_VR_SAIDAS_NF_NAO_OK        := 0;
                                                   V_QT_SAIDAS_NF_NAO_OK        := 0;
                                                   V_VR_DEVOLUCOES_NF           := 0;
                                                   V_QT_DEVOLUCOES_NF           := 0;
                                                   V_VR_RETIRADAS_TOTAL         := 0; 
                                                   V_QT_RETIRADAS_TOTAL         := 0;
                                                   V_VR_RETIRADAS_TOTAL_NAO_OK  := 0; 
                                                   V_QT_RETIRADAS_TOTAL_NAO_OK  := 0;
                                                   V_QT_ESTOQUE_INICIAL         := 0;
                                                   V_VR_ESTOQUE_INICIAL         := 0;
                                                   V_CUSTO_UNIT_ESTOQUE         := 0;
                                                   V_QT_ESTOQUE_FINAL           := 0;
                                                   V_VR_ESTOQUE_FINAL           := 0;
                                                   V_QT_EFETIVAMENTE_SOLICITADA := 0;
                                                   V_QT_ORIGINAL_SOLICITADA     := 0;
                                                   V_QT_PLANEJADA               := 0;
             END LOOP;
      DELETE FROM CONSPLAN WHERE NRCONSPLAN = V_CDSEQUENCIAL;
      END LOOP;
      
      FOR C_FILIAL IN (SELECT DISTINCT FILIAL.CDFILIAL,
                              FILIAL.NMFILIAL,
                              EMPRESA.CDEMPRESA,
                              EMPRESA.NMEMPRESA,
                              PARAMFILIAL.DTPROCESSA,
                              FILIAL.DTINICIALBI, 
                              PARAMFILIAL.IDCOMCUSPERC,
                              CASE WHEN (FILIAL.IDFUNCAOFILI = 'O')  THEN 'OPERADOR LOGISTICO' ELSE 'OUTROS' END DSFUNCAOFILI,
                              REGIAO.CDREGIAO,
                              NVL(REGIAO.NMREGIAO,'SEM CADASTRO') NMREGIAO,
                              SEGMERCADO.CDSEGMER CDSEGMERCADO,
                              NVL(SEGMERCADO.DSSEGMER,'SEM CADASTRO') NMSEGMERCADO,
                              GER_OPERAC.CDOPERADOR CDGOPERAC,
                              NVL(GER_OPERAC.NMOPERADOR,'SEM CADASTRO') NMGERENTE_OPERACIONAL,
                              SUPERV.CDOPERADOR CDSUPERVISOR,
                              NVL(SUPERV.NMOPERADOR,'SEM CADASTRO') NMSUPERVISOR,
                              AREAGERE.CDAREAGERE,
                              NVL(AREAGERE.NMAREAGERE,'SEM CADASTRO') NMAREAGERE,
                              PLANEJADORA.CDOPERADOR CDPLANEJADORA,
                              NVL(PLANEJADORA.NMOPERADOR,'SEM CADASTRO') NMPLANEJADORA,
                              GERENTE_UNIDADE.CDOPERADOR CDGUNIDADE,
                              NVL(GERENTE_UNIDADE.CDOPERADOR, 'SEM CADASTRO') NMGUNIDADE,
                              PARAMFILIAL.CDTPOCUSTO_PADRAO,
                              PARAMFILIAL.DSTPCUSTO_PADRAO,
                              FILIAL.NRORG
                         FROM FILIAL
                         INNER JOIN (SELECT DECODE(CDTIPCUSTEST,NULL,'03-Custo Mdio Lquido da poca',CDTIPCUSTEST||'-'||NMTIPOCUSTO) DSTPCUSTO_PADRAO,
                                           NVL(PARAMFILIAL.CDTIPCUSTEST,'03') CDTPOCUSTO_PADRAO,
                                           PARAMFILIAL.DTPROCESSA,
                                           PARAMFILIAL.CDFILIAL,
                                           IDCOMCUSPERC
                                      FROM PARAMFILIAL
                                      LEFT JOIN TIPOCUSTO
                                        ON PARAMFILIAL.CDTIPCUSTEST = TIPOCUSTO.CDTIPOCUSTO) PARAMFILIAL
                           ON FILIAL.CDFILIAL = PARAMFILIAL.CDFILIAL
                         LEFT JOIN REGIAO
                           ON FILIAL.CDREGIAO = REGIAO.CDREGIAO
                         LEFT JOIN SEGMERCADO
                           ON FILIAL.CDSEGMER = SEGMERCADO.CDSEGMER
                         LEFT JOIN OPERADOR GER_OPERAC
                           ON FILIAL.CDGOPERAC = GER_OPERAC.CDOPERADOR
                         LEFT JOIN OPERADOR SUPERV
                           ON FILIAL.CDSUPERVISOR = SUPERV.CDOPERADOR
                         LEFT JOIN AREAGERE
                           ON FILIAL.CDAREAGERE = AREAGERE.CDAREAGERE
                         LEFT JOIN OPERADOR PLANEJADORA
                           ON FILIAL.CDPLANEJADORA = PLANEJADORA.CDOPERADOR
                         INNER JOIN EMPRESA
                           ON FILIAL.CDEMPRESA = EMPRESA.CDEMPRESA
                         LEFT JOIN OPERADOR GERENTE_UNIDADE
                           ON FILIAL.CDGUNIDADE = GERENTE_UNIDADE.CDOPERADOR
                         WHERE FILIAL.DTINICIALBI IS NOT NULL
                           AND TO_CHAR(TO_DATE(FILIAL.DTINICIALBI),'YYYYMM') <= TO_CHAR(TO_DATE(V_DTINI), 'YYYYMM')
                           AND FILIAL.CDFILIAL NOT IN(SELECT CDFILIAL  
                                                        FROM FILIAL 
                                                       WHERE IDFILCENTPME = 'S' 
                                                         AND IDTPFILIALCENT = 'M') 
                           AND FILIAL.CDFILIAL NOT IN(SELECT  FL.CDFILIAL CDMERENDA
                                                         FROM FILIAL FL
                                                        INNER JOIN (SELECT CDFILIAL CDCENTRAL, NMFILIAL NMCENTRAL FROM FILIAL WHERE IDFILCENTPME = 'S' AND IDTPFILIALCENT = 'M') CENTRAL
                                                           ON FL.CDFILCENTPME = CENTRAL.CDCENTRAL
                                                        INNER JOIN PARAMFILIAL P
                                                           ON P.CDFILIAL = CENTRAL.CDCENTRAL
                                                        INNER JOIN EMPRESA EMP
                                                           ON EMP.CDEMPRESA = FL.CDEMPRESA)
                        GROUP BY FILIAL.CDFILIAL, FILIAL.NMFILIAL, PARAMFILIAL.IDCOMCUSPERC, PARAMFILIAL.DTPROCESSA, FILIAL.IDFUNCAOFILI, REGIAO.NMREGIAO, SEGMERCADO.DSSEGMER, GER_OPERAC.NMOPERADOR, FILIAL.CDFILCENTPME, FILIAL.IDFILCENTPME, FILIAL.IDTPFILIALCENT, FILIAL.DTINICIALBI,
                                 FILIAL.CDGUNIDADE, SUPERV.CDOPERADOR, SUPERV.NMOPERADOR, AREAGERE.CDAREAGERE, AREAGERE.NMAREAGERE, PLANEJADORA.NMOPERADOR, PARAMFILIAL.CDTPOCUSTO_PADRAO, PARAMFILIAL.DSTPCUSTO_PADRAO, FILIAL.NRORG, EMPRESA.CDEMPRESA, EMPRESA.NMEMPRESA,
                                 REGIAO.CDREGIAO, SEGMERCADO.CDSEGMER, GER_OPERAC.CDOPERADOR, PLANEJADORA.CDOPERADOR, GERENTE_UNIDADE.CDOPERADOR
                        ORDER BY FILIAL.CDFILIAL)LOOP
           
         NOVO_CODIGO('CONSPLAN'||C_FILIAL.CDFILIAL, V_CDSEQUENCIAL,1);
         V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);
         CONSUMO_PLANEJADO_PLA(C_FILIAL.CDFILIAL, 'T', V_DTINI, V_DATAFINAL, 'T', 'CFP', 'N', 0, 'N', V_CDSEQUENCIAL, '0', 'zzzzzzzzzz', '', '_'||TO_CHAR(V_DTINI, 'YYYYMMDD')||'_','_'||TO_CHAR(V_DATAFINAL, 'YYYYMMDD')||'_');
      
            FOR C_PRODUTO IN(SELECT P.CDPRODUTO, P.NMPRODUTO, VRARREDCMP, VRFATOCONV, DTMESCARD
                               FROM(SELECT CDPRODCPLA CDPRODUTO,  TRUNC(MIN(DTCONSPLAN),'MM') DTMESCARD
                                      FROM CONSPLAN CP
                                     WHERE TO_CHAR(DTCONSPLAN, 'YYYYMM') = TO_CHAR(TO_DATE(V_DATAFINAL),'YYYYMM')
                                       AND CDFILICPLA = C_FILIAL.CDFILIAL
                                       AND NRCONSPLAN = V_CDSEQUENCIAL
                                     GROUP BY CDPRODCPLA
                                     UNION
                                    SELECT CDPRODUTO, TRUNC(MIN(IT.DTLANCMOVI),'MM') DTMESCARD
                                      FROM ITLANCTOEST IT
                                     WHERE TO_CHAR(IT.DTLANCMOVI, 'YYYYMM') = TO_CHAR(TO_DATE(V_DATAFINAL),'YYYYMM')
                                       AND IT.CDFILIMOVI = C_FILIAL.CDFILIAL
                                       AND IT.IDTIPOMOVI IN (2, 3, 4)
                                     GROUP BY CDPRODUTO) PROD_PLAN, PRODUTO P
                              WHERE PROD_PLAN.CDPRODUTO = P.CDPRODUTO
                              GROUP BY P.CDPRODUTO, P.NMPRODUTO, VRARREDCMP, VRFATOCONV, DTMESCARD
                              ORDER BY P.CDPRODUTO)LOOP
            
            
                      ------------------------------------------------------------------------------
                      --------------------------- CONSULTA CONSUMO PLANEJADO------------------------
                      BEGIN 
                         SELECT SUM(QTCONSPLAN) 
                           INTO V_QT_PLANEJADA
                           FROM CONSPLAN 
                          WHERE CDFILICPLA   = C_FILIAL.CDFILIAL
                            AND CDPRODCPLA   = C_PRODUTO.CDPRODUTO
                            AND NRCONSPLAN   = V_CDSEQUENCIAL
                          ORDER BY DTCONSPLAN;
                      EXCEPTION 
                            WHEN OTHERS THEN 
                            V_QT_PLANEJADA := 0; 
                      END;
                      
                      ------------------------------------------------------------------------------
                      -------------------------------CONSULTA ENTRADAS_NF---------------------------
                        V_TIPO_LANC := 2;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(VRLANCTOEST * QTLANCTOEST),0)), --ITLANCTOEST.IDEVOLESTOQ = 'S' /*SOMENTE O LANCAMENTOS QUE EVOLUI ESTOQUE*/
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(VRLANCTOEST * QTLANCTOEST),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST),0))
                             INTO V_VR_ENTRADAS_NF, V_QT_ENTRADAS_NF, V_VR_ENTRADAS_NF_NAO_OK, V_QT_ENTRADAS_NF_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_FILIAL.CDFILIAL
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_ENTRADAS_NF := 0; 
                             V_QT_ENTRADAS_NF := 0;
                             V_VR_ENTRADAS_NF_NAO_OK := 0;
                             V_QT_ENTRADAS_NF_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTAS SAIDAS NF-------------------------------
                      V_TIPO_LANC := 4;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',QTLANCTOEST,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',QTLANCTOEST,0))
                             INTO V_VR_SAIDAS_NF, V_QT_SAIDAS_NF, V_VR_SAIDAS_NF_NAO_OK, V_QT_SAIDAS_NF_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_FILIAL.CDFILIAL
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_SAIDAS_NF        := 0; 
                             V_QT_SAIDAS_NF        := 0;
                             V_VR_SAIDAS_NF_NAO_OK := 0;
                             V_QT_SAIDAS_NF_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTAS DEVOLUCOES------------------------------
                      V_TIPO_LANC := 5;
                        
                        BEGIN
                           SELECT SUM((QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, C_FILIAL.CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE)))), 
                                  SUM(QTLANCTOEST)
                             INTO V_VR_DEVOLUCOES_NF, V_QT_DEVOLUCOES_NF
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_FILIAL.CDFILIAL
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_DEVOLUCOES_NF := 0; 
                             V_QT_DEVOLUCOES_NF := 0;
                        END;
                      -----------------------------------------------------------------------------
                      ----------------------------CONSULTA RETIRADAS-------------------------------
                      V_TIPO_LANC := 3;
                        
                        BEGIN
                           SELECT SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'S',QTLANCTOEST,0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',(QTLANCTOEST * CUSTO_PRODUTO(ITLANCTOEST.CDFILIMOVI, ITLANCTOEST.CDPRODMOVI, V_CDTPOCUSTO_PADRAO, ITLANCTOEST.DTLANCMOVI, TRUNC(SYSDATE))),0)),
                                  SUM(DECODE(ITLANCTOEST.IDEVOLESTOQ,'N',QTLANCTOEST,0))
                             INTO V_VR_RETIRADAS_TOTAL, V_QT_RETIRADAS_TOTAL, V_VR_RETIRADAS_TOTAL_NAO_OK, V_QT_RETIRADAS_TOTAL_NAO_OK
                             FROM ITLANCTOEST
                            WHERE ITLANCTOEST.DTLANCMOVI BETWEEN  V_DTINI AND V_DATAFINAL
                              AND ITLANCTOEST.CDFILIMOVI = C_FILIAL.CDFILIAL
                              AND ITLANCTOEST.CDPRODMOVI = C_PRODUTO.CDPRODUTO
                              AND ITLANCTOEST.IDTIPOMOVI = V_TIPO_LANC;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_VR_RETIRADAS_TOTAL        := 0; 
                             V_QT_RETIRADAS_TOTAL        := 0;
                             V_VR_RETIRADAS_TOTAL_NAO_OK := 0; 
                             V_QT_RETIRADAS_TOTAL_NAO_OK := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTA ESTOQUE INICIAL--------------------------
                                          
                      V_DTPOSESTCON := TO_CHAR(RETORNA_DTPOSESTCON(TO_DATE(V_DTINI), C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO),'DD/MM/YYYY');
                      V_CUSTO_UNIT_ESTOQUE := CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, C_FILIAL.CDTPOCUSTO_PADRAO, V_DTPOSESTCON, TRUNC(SYSDATE)); 
                        
                        BEGIN
                          SELECT SUM(P.QTESTDIACON), SUM(P.QTESTDIACON * V_CUSTO_UNIT_ESTOQUE)
                            INTO V_QT_ESTOQUE_INICIAL, V_VR_ESTOQUE_INICIAL
                            FROM POSESTCONS P
                           WHERE P.CDFILIAL = C_FILIAL.CDFILIAL
                             AND P.CDPRODUTO       = C_PRODUTO.CDPRODUTO
                             AND P.QTESTDIACON    <> 0
                             AND P.DTPOSESTCON     = V_DTPOSESTCON;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_QT_ESTOQUE_INICIAL := 0; 
                             V_VR_ESTOQUE_INICIAL := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ----------------------------CONSULTA ESTOQUE FINAL----------------------------
                      
                      V_DTPOSESTCON := TO_CHAR(RETORNA_DTPOSESTCON((TO_DATE(V_DATAFINAL)+1), C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO),'DD/MM/YYYY');
                      V_CUSTO_UNIT_ESTOQUE := CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, C_FILIAL.CDTPOCUSTO_PADRAO, V_DTPOSESTCON, TRUNC(SYSDATE)); 
                      
                        BEGIN
                          SELECT SUM(P.QTESTDIACON), SUM(P.QTESTDIACON * V_CUSTO_UNIT_ESTOQUE)
                            INTO V_QT_ESTOQUE_FINAL, V_VR_ESTOQUE_FINAL
                            FROM POSESTCONS P
                           WHERE P.CDFILIAL = C_FILIAL.CDFILIAL
                             AND P.CDPRODUTO       = C_PRODUTO.CDPRODUTO
                             AND P.QTESTDIACON    <> 0
                             AND P.DTPOSESTCON     = V_DTPOSESTCON;
                        EXCEPTION 
                             WHEN OTHERS THEN 
                             V_QT_ESTOQUE_FINAL := 0; 
                             V_VR_ESTOQUE_FINAL := 0;
                        END;
                      ------------------------------------------------------------------------------
                      ------------------------CONSULTA QUANTIDADE SOLICITADA------------------------
                        
                        BEGIN 
                           IF C_PRODUTO.VRARREDCMP > 0 THEN 
                             SELECT CEIL((SUM(ITS.QTSOLIPROD)/C_PRODUTO.VRFATOCONV)/C_PRODUTO.VRARREDCMP) * C_PRODUTO.VRARREDCMP AS QT_EFETIVAMENTE_SOLICITADA,
                                     CEIL((SUM(CASE WHEN ITS.QTSOLIORIG IS NOT NULL THEN ITS.QTSOLIORIG
                                                    WHEN (SELECT MIN(LOG.DTOPERSOL)
                                                                FROM MOVOPSOL LOG
                                                               WHERE LOG.CDFILSOLMOV = ITS.CDFILSOLI
                                                                 AND LOG.CDFILLANMOV = ITS.CDFILLAN
                                                                 AND LOG.NRSOLIMOV   = ITS.NRSOLICMP
                                                                 AND LOG.CDPRODUTO   = ITS.CDPRODUTO
                                                                 AND ROWNUM = 1
                                                                 AND LOG.DTENTROPER = ITS.DTPROGENTR)IS NOT NULL THEN (SELECT L.QTANTOPER
                                                                                                                      FROM MOVOPSOL L
                                                                                                                     WHERE L.CDFILSOLMOV = ITS.CDFILSOLI
                                                                                                                       AND L.CDFILLANMOV = ITS.CDFILLAN
                                                                                                                       AND L.NRSOLIMOV   = ITS.NRSOLICMP
                                                                                                                       AND L.CDPRODUTO   = ITS.CDPRODUTO
                                                                                                                       AND L.DTENTROPER  = ITS.DTPROGENTR
                                                                                                                       AND ROWNUM=1
                                                                                                                       AND L.DTOPERSOL = (SELECT MIN(LOG.DTOPERSOL)
                                                                                                                                            FROM MOVOPSOL LOG, OPERADOR S
                                                                                                                                           WHERE LOG.CDFILSOLMOV = L.CDFILSOLMOV
                                                                                                                                             AND LOG.CDFILLANMOV = L.CDFILLANMOV
                                                                                                                                             AND LOG.NRSOLIMOV   = L.NRSOLIMOV
                                                                                                                                             AND LOG.CDOPERADOR  = S.CDOPERADOR
                                                                                                                                             AND LOG.CDPRODUTO   = L.CDPRODUTO
                                                                                                                                             AND LOG.DTENTROPER  = L.DTENTROPER))  
                                                    ELSE ITS.QTSOLIPROD END)/C_PRODUTO.VRFATOCONV)/C_PRODUTO.VRARREDCMP) * C_PRODUTO.VRARREDCMP AS QT_ORIGINAL_SOLICITADA
                                INTO V_QT_EFETIVAMENTE_SOLICITADA, V_QT_ORIGINAL_SOLICITADA
                                FROM ITEMSOLI ITS, PRODUTO PS
                               WHERE ITS.CDPRODUTO = PS.CDPRODUTO
                                 AND PS.CDPRODESTO = C_PRODUTO.CDPRODUTO 
                                 AND ITS.CDFILSOLI = C_FILIAL.CDFILIAL
                                 AND ITS.DTPROGENTR BETWEEN V_DTINI AND V_DATAFINAL;   
                           ELSE 
                              SELECT SUM(ITS.QTSOLIPROD)/C_PRODUTO.VRFATOCONV AS QT_EFETIVAMENTE_SOLICITADA,
                                     SUM(CASE WHEN ITS.QTSOLIORIG IS NOT NULL THEN ITS.QTSOLIORIG
                                              WHEN (SELECT MIN(LOG.DTOPERSOL)
                                                          FROM MOVOPSOL LOG
                                                         WHERE LOG.CDFILSOLMOV = ITS.CDFILSOLI
                                                           AND LOG.CDFILLANMOV = ITS.CDFILLAN
                                                           AND LOG.NRSOLIMOV   = ITS.NRSOLICMP
                                                           AND LOG.CDPRODUTO   = ITS.CDPRODUTO
                                                           AND ROWNUM = 1
                                                           AND LOG.DTENTROPER = ITS.DTPROGENTR)IS NOT NULL THEN (SELECT L.QTANTOPER
                                                                                                                FROM MOVOPSOL L
                                                                                                               WHERE L.CDFILSOLMOV = ITS.CDFILSOLI
                                                                                                                 AND L.CDFILLANMOV = ITS.CDFILLAN
                                                                                                                 AND L.NRSOLIMOV   = ITS.NRSOLICMP
                                                                                                                 AND L.CDPRODUTO   = ITS.CDPRODUTO
                                                                                                                 AND L.DTENTROPER  = ITS.DTPROGENTR
                                                                                                                 AND ROWNUM=1
                                                                                                                 AND L.DTOPERSOL = (SELECT MIN(LOG.DTOPERSOL)
                                                                                                                                      FROM MOVOPSOL LOG, OPERADOR S
                                                                                                                                     WHERE LOG.CDFILSOLMOV = L.CDFILSOLMOV
                                                                                                                                       AND LOG.CDFILLANMOV = L.CDFILLANMOV
                                                                                                                                       AND LOG.NRSOLIMOV   = L.NRSOLIMOV
                                                                                                                                       AND LOG.CDOPERADOR  = S.CDOPERADOR
                                                                                                                                       AND LOG.CDPRODUTO   = L.CDPRODUTO
                                                                                                                                       AND LOG.DTENTROPER  = L.DTENTROPER))  
                                              ELSE ITS.QTSOLIPROD END)/C_PRODUTO.VRFATOCONV AS QT_ORIGINAL_SOLICITADA
                                INTO V_QT_EFETIVAMENTE_SOLICITADA, V_QT_ORIGINAL_SOLICITADA 
                                FROM ITEMSOLI ITS, PRODUTO PS 
                               WHERE ITS.CDPRODUTO = PS.CDPRODUTO
                                 AND PS.CDPRODESTO = C_PRODUTO.CDPRODUTO
                                 AND ITS.CDFILSOLI = C_FILIAL.CDFILIAL
                                 AND TRUNC(ITS.DTPROGENTR) BETWEEN V_DTINI AND V_DATAFINAL;
                           END IF; 
                        EXCEPTION 
                            WHEN OTHERS THEN 
                            V_QT_EFETIVAMENTE_SOLICITADA := 0; 
                            V_QT_ORIGINAL_SOLICITADA := 0;
                        END; 
                      ------------------------------------------------------------------------------
                      INSERT INTO DM_RAST_PRODUTO_PLANEJADO(
                                                   CDFILCENTPME,
                                                   NMFILCENTPME,
                                                   CDFILIAL,
                                                   NMFILIAL,
                                                   CDEMPRESA,
                                                   NMEMPRESA,
                                                   DSMESCARD,
                                                   CDPRODUTO,
                                                   NMPRODUTO,
                                                   CDSEGMERCADO,
                                                   NMSEGMERCADO,
                                                   CDAREAGERE,
                                                   NMAREAGERE,
                                                   CDGOPERAC,
                                                   NMGOPERAC,
                                                   CDSUPERVISOR,
                                                   NMSUPERVISOR,
                                                   CDPLANEJADORA,
                                                   NMPLANEJADORA,
                                                   CDGUNIDADE,
                                                   NMGUNIDADE,
                                                   VRCUST_PLAN1,
                                                   VRCUST_PLAN2,
                                                   VRCUST_PLAN3,
                                                   QTPLANEJADA,
                                                   QT_EFET_SOLICIT,
                                                   QT_ORIG_SOLICIT,
                                                   VRCUST_ULT_COMPRA,
                                                   VRCUST_ESTOQUE,
                                                   VR_ENTRADAS_NF,
                                                   QT_ENTRADAS,
                                                   VR_ENTRADAS_NF_NAO_OK,
                                                   QT_ENTRADAS_NAO_OK,
                                                   VR_SAIDAS,
                                                   QT_SAIDAS,
                                                   VR_SAIDAS_NAO_OK,
                                                   QT_SAIDAS_NAO_OK,
                                                   VR_DEVOLUCOES,
                                                   QT_DEVOLUCOES,
                                                   VR_RETIRADAS,
                                                   QT_RETIRADAS,
                                                   VR_RETIRADAS_NAO_OK,
                                                   QT_RETIRADAS_NAO_OK,
                                                   QT_ESTOQUE_INICIAL,
                                                   VR_ESTOQUE_INICIAL,
                                                   QT_ESTOQUE_FINAL,
                                                   VR_ESTOQUE_FINAL,
                                                   CDANOBI,
                                                   CDMESBI,
                                                   CDMESBI_MMYYYY,
                                                   DSMESBI_MMYYYY,
                                                   DSBIMESTRE,
                                                   DSTRIMESTRE,
                                                   DSQUADIMESTRE,
                                                   DSSEMESTRE)
                                            VALUES(
                                                   NULL,
                                                   'N/A',
                                                   C_FILIAL.CDFILIAL,
                                                   C_FILIAL.NMFILIAL,
                                                   C_FILIAL.CDEMPRESA,
                                                   C_FILIAL.NMEMPRESA,
                                                   C_PRODUTO.DTMESCARD,
                                                   C_PRODUTO.CDPRODUTO,
                                                   C_PRODUTO.NMPRODUTO,
                                                   C_FILIAL.CDSEGMERCADO,
                                                   C_FILIAL.NMSEGMERCADO,
                                                   C_FILIAL.CDAREAGERE,
                                                   C_FILIAL.NMAREAGERE,
                                                   C_FILIAL.CDGOPERAC,
                                                   C_FILIAL.NMGERENTE_OPERACIONAL,
                                                   C_FILIAL.CDSUPERVISOR,
                                                   C_FILIAL.NMSUPERVISOR,
                                                   C_FILIAL.CDPLANEJADORA,
                                                   C_FILIAL.NMPLANEJADORA,
                                                   C_FILIAL.CDGUNIDADE,
                                                   C_FILIAL.NMGUNIDADE,
                                                   NVL(CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO1, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO2, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, V_NRTIPOCUSTO3, V_DTINI, TRUNC(SYSDATE)),0),
                                                   NVL(V_QT_PLANEJADA,0),
                                                   NVL(V_QT_EFETIVAMENTE_SOLICITADA,0),
                                                   NVL(V_QT_ORIGINAL_SOLICITADA,0),
                                                   NVL(CUSTO_PRODUTO(C_FILIAL.CDFILIAL, C_PRODUTO.CDPRODUTO, 8, V_DTPOSESTCON, TRUNC(SYSDATE)),0),
                                                   NVL(V_CUSTO_UNIT_ESTOQUE,0),
                                                   NVL(V_VR_ENTRADAS_NF,0),
                                                   NVL(V_QT_ENTRADAS_NF,0), 
                                                   NVL(V_VR_ENTRADAS_NF_NAO_OK,0), 
                                                   NVL(V_QT_ENTRADAS_NF_NAO_OK,0),
                                                   NVL(V_VR_SAIDAS_NF,0),
                                                   NVL(V_QT_SAIDAS_NF,0),
                                                   NVL(V_VR_SAIDAS_NF_NAO_OK,0),
                                                   NVL(V_QT_SAIDAS_NF_NAO_OK,0),
                                                   NVL(V_VR_DEVOLUCOES_NF,0),
                                                   NVL(V_QT_DEVOLUCOES_NF,0),
                                                   NVL(V_VR_RETIRADAS_TOTAL,0),
                                                   NVL(V_QT_RETIRADAS_TOTAL,0),
                                                   NVL(V_VR_RETIRADAS_TOTAL_NAO_OK,0),
                                                   NVL(V_QT_RETIRADAS_TOTAL_NAO_OK,0),
                                                   NVL(V_QT_ESTOQUE_INICIAL,0),
                                                   NVL(V_VR_ESTOQUE_INICIAL,0),
                                                   NVL(V_QT_ESTOQUE_FINAL,0),
                                                   NVL(V_VR_ESTOQUE_FINAL,0),
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'YYYY'),--CDANOBI
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MM'),--CDMESBI
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MM/YYYY'),--CDMESBI_MMYYYY
                                                   TO_CHAR(TO_DATE(V_DATAFINAL),'MON/YYYY'),--DSMESBI_MMYYYY
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 2) + 1)||' Bim',--DSBIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 3) + 1)||' Tri',--DSTRIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 4) + 1)||' Qua',--DSQUADIMESTRE
                                                   TO_CHAR(TRUNC((TO_CHAR(TO_DATE(V_DATAFINAL),'MM') - 1) / 6) + 1)||' Sem'--DSSEMESTRE
                                                   ); 
                                                    COMMIT;
                                                   V_VR_ENTRADAS_NF             := 0; 
                                                   V_QT_ENTRADAS_NF             := 0;
                                                   V_VR_ENTRADAS_NF_NAO_OK      := 0;
                                                   V_QT_ENTRADAS_NF_NAO_OK      := 0;
                                                   V_VR_SAIDAS_NF               := 0; 
                                                   V_QT_SAIDAS_NF               := 0;
                                                   V_VR_SAIDAS_NF_NAO_OK        := 0;
                                                   V_QT_SAIDAS_NF_NAO_OK        := 0;
                                                   V_VR_DEVOLUCOES_NF           := 0;
                                                   V_QT_DEVOLUCOES_NF           := 0;
                                                   V_VR_RETIRADAS_TOTAL         := 0; 
                                                   V_QT_RETIRADAS_TOTAL         := 0;
                                                   V_VR_RETIRADAS_TOTAL_NAO_OK  := 0; 
                                                   V_QT_RETIRADAS_TOTAL_NAO_OK  := 0;
                                                   V_QT_ESTOQUE_INICIAL         := 0;
                                                   V_VR_ESTOQUE_INICIAL         := 0;
                                                   V_CUSTO_UNIT_ESTOQUE         := 0;
                                                   V_QT_ESTOQUE_FINAL           := 0;
                                                   V_VR_ESTOQUE_FINAL           := 0;
                                                   V_QT_EFETIVAMENTE_SOLICITADA := 0;
                                                   V_QT_ORIGINAL_SOLICITADA     := 0;
                                                   V_QT_PLANEJADA               := 0;
               END LOOP;
        END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
   EXCEPTION 
     WHEN OTHERS THEN 
     EXIT;
   END; 
   END LOOP;            -- loop por ms
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_RAST_PRODUTO_PLANEJADO','6.10.xxx'); END;
/
